scispace - formally typeset
Search or ask a question

Showing papers by "Alejandro López-Ortiz published in 2003"


Proceedings ArticleDOI
27 Oct 2003
TL;DR: This paper presents a deterministic algorithm for identifying frequent items in sliding windows defined over real-time packet streams that uses limited memory, requires constant processing time per packet, makes only one pass over the data, and is shown to work well when tested on TCP traffic logs.
Abstract: Internet traffic patterns are believed to obey the power law, implying that most of the bandwidth is consumed by a small set of heavy users. Hence, queries that return a list of frequently occurring items are important in the analysis of real-time Internet packet streams. While several results exist for computing frequent item queries using limited memory in the infinite stream model, in this paper we consider the limited-memory sliding window model. This model maintains the last $N$ items that have arrived at any given time and forbids the storage of the entire window in memory. We present a deterministic algorithm for identifying frequent items in sliding windows defined over real-time packet streams. The algorithm uses limited memory, requires constant processing time per packet (amortized), makes only one pass over the data, and is shown to work well when tested on TCP traffic logs.

150 citations


Proceedings ArticleDOI
27 Oct 2003
TL;DR: In this article, the minimum number of required beacons on a network under a BGP-like routing policy is shown to be NP-hard and at best Ω(log n)-approximable.
Abstract: Internet topology information is only made available in aggregate form by standard routing protocols. Connectivity information and latency characteristics must therefore be inferred using indirect techniques. In this paper we consider measurements using a distributed set of measurement points or beacons. We show that computing the minimum number of required beacons on a network under a BGP-like routing policy is NP-hard and at best Ω(log n)-approximable. In the worst case at least (n-1)/3 and at most (n+1)/3 beacons are required for a network with n nodes. We then introduce some observations that allow us to propose a relatively small candidate set of beacons for the current Internet topology. The set proposed has properties with relevant applications for all-paths routing on the public Internet and performance based routing.

95 citations


Proceedings Article
09 Aug 2003
TL;DR: This paper presents a fast, simple algorithm for bounds consistency propagation of the alldifferent constraint and shows that this algorithm outperforms existing bounds consistency algorithms and also outperforms--on problems with an easily identifiable property-state-ofthe-art commercial implementations of propagators for stronger forms of local consistency.
Abstract: In constraint programming one models a problem by stating constraints on acceptable solutions. The constraint model is then usually solved by interleaving backtracking search and constraint propagation. Previous studies have demonstrated that designing special purpose constraint propagators for commonly occurring constraints can significantly improve the efficiency of a constraint programming approach. In this paper we present a fast, simple algorithm for bounds consistency propagation of the alldifferent constraint. The algorithm has the same worst case behavior as the previous best algorithm but is much faster in practice. Using a variety of benchmark and random problems, we show that our algorithm outperforms existing bounds consistency algorithms and also outperforms--on problems with an easily identifiable property-state-ofthe-art commercial implementations of propagators for stronger forms of local consistency.

79 citations


Proceedings ArticleDOI
11 Oct 2003
TL;DR: It is shown that for a multilevel memory hierarchy, a simple cache-oblivious structure almost replicates the performance of an optimal parameterized k-level DAM structure, and it is demonstrated that as k grows, the search costs of the optimal k- level DAM search structure and the optimal cache-OBlivious search structure rapidly converge.
Abstract: Tight bounds on the cost of cache-oblivious searching are proved. It is shown that no cache-oblivious search structure can guarantee that a search performs fewer than lg e log/sub B/N block transfers between any two levels of the memory hierarchy. This lower bound holds even if all of the block sizes are limited to be powers of 2. A modified version of the van Emde Boas layout is proposed, whose expected block transfers between any two levels of the memory hierarchy arbitrarily close to [lg e + O(lg lg B/ lgB)] logB N + O(1). This factor approaches lg e /spl ap/ 1.443 as B increases. The expectation is taken over the random placement of the first element of the structure in memory. As searching in the disk access model (DAM) can be performed in log/sub B/N + 1 block transfers, this result shows a separation between the 2-level DAM and cache-oblivious memory-hierarchy models. By extending the DAM model to k levels, multilevel memory hierarchies can be modeled. It is shown that as k grows, the search costs of the optimal k-level DAM search structure and of the optimal cache-oblivious search structure rapidly converge. This demonstrates that for a multilevel memory hierarchy, a simple cache-oblivious structure almost replicates the performance of an optimal parameterized k-level DAM structure.

34 citations


Journal ArticleDOI
TL;DR: A tradeoff theorem is given between the area and the aspect ratio required by any planar straight-line drawing of K2,n on the integer lattice that shows that if the drawing is contained in a rectangle of area O(n) then the rectangle must have aspect ratio Ω (n).

5 citations


Journal ArticleDOI
TL;DR: In this paper, the authors explore the natural question of whether all NP-complete problems have a common restriction under which they are polynomially solvable, and give a polynomial-time algorithm to determine whether a regular language is universally easy.

5 citations


Proceedings Article
01 Jan 2003
TL;DR: This work considers the problem of finding the shortest curve in the plane that has unit width, and presents a simpler proof, which exploits the fact that the width of a polygon does not decrease under a certain convexification operation.
Abstract: We consider the problem of finding the shortest curve in the plane that has unit width. This problem was first posed as the “river shore” puzzle by Ogilvy (1972) and is related to the area of on-line searching. Adhikari and Pitman (1989) proved that the optimal solution has length 2.2782 ... We present a simpler proof, which exploits the fact that the width of a polygon does not decrease under a certain convexification operation.

4 citations


Journal ArticleDOI
TL;DR: A strategy for finding a target of unknown location in a star-shaped polygon with a competitive ratio of 11.52 is proposed and a lower bound of 9 is provided for the Competitive ratio of searching in aStar-shapedpolygon which is close to the upper bound.
Abstract: We study the problem of on-line searching for a target inside a polygon. In particular, we propose a strategy for finding a target of unknown location in a star-shaped polygon with a competitive ratio of 11.52. We also provide a lower bound of 9 for the competitive ratio of searching in a star-shaped polygon which is close to the upper bound. A similar task is the on-line recognition of a star-shaped polygon P. Here, the robot travels on a path that allows it to decide whether P is star-shaped or not. We present a strategy with a competitive ratio of 28.85 and give a lower bound of √82 for this problem.

4 citations


Proceedings ArticleDOI
08 Jun 2003
TL;DR: Two variants of the well-known "sailor in the fog" puzzle are considered, one set in three dimensions and the other in four dimensions, and a solution of length 2.2782 is described, which is proved to be optimal.
Abstract: We consider two variants of the well-known "sailor in the fog" puzzle. The first version (the "asteroid surveying" problem) is set in three dimensions and asks for the shortest curve that starts at the origin and intersects all planes at unit distance from the origin. Several possible solutions are suggested in the video, including a curve of length less than 12.08. The second version (the "river shore" problem) asks for the shortest curve in the plane that has unit width. A solution of length 2.2782 is described, which we have proved to be optimal.

4 citations


Book ChapterDOI
16 Sep 2003
TL;DR: This work shows that an adaptive form of pyramid broadcasting is optimal for both measures of resource consumption and performance simultaneously, up to constant factors, and shows that the maximum throughput for a fixed network bandwidth cannot be obtained by any online strategy.
Abstract: We consider the transmission of a movie over a broadcast network to support several viewers who start watching at arbitrary times, after a wait of at most t wait minutes. A recent approach called harmonic broadcasting optimally solves the case of many viewers watching a movie using a constant amount of bandwidth. We consider the more general setting and v changes dynamically. A natural objective is to minimize the amount of resources required to achieve this task. We introduce two natural measures of resource consumption and performance—total bandwidth usage and maximum momentary bandwidth usage—and propose strategies which are optimal for each of them. In particular, we show that an adaptive form of pyramid broadcasting is optimal for both measures simultaneously, up to constant factors. We also show that the maximum throughput for a fixed network bandwidth cannot be obtained by any online strategy.

3 citations


Book ChapterDOI
25 Jul 2003
TL;DR: This work provides adaptive algorithms for both the verification scenario (given an independent set, is it X?) and the discovery scenario (find X without any information) under some assumptions, which use an asymptotically optimal number of queries in every instance.
Abstract: Consider a game in a given set of intervals (and their implied interval graph G) in which the adversary chooses an independent set X in G. The goal is to discover this hidden independent set X by making the fewest queries of the form "Is point p covered by an interval in X?" Our interest in this problem stems from two applications: experimental gene discovery and the game of Battleship (in a 1-dimensional setting). We provide adaptive algorithms for both the verification scenario (given an independent set, is it X?) and the discovery scenario (find X without any information). Under some assumptions, these algorithms use an asymptotically optimal number of queries in every instance.